# Creating A Plugin

If one of the [independently maintained plugins](/v6/plugins/list.md) doesn't suit your needs, then you can create your own, to achieve maximum customizability.

Most plugins create either new [Tile Providers](/v6/layers/tile-layer/tile-providers.md), or new [Layers](/v6/usage/layers.md). Some plugins just provide additional useful tools.

{% content-ref url="/pages/Iv08n8fQ8A1XeZG65Oi7" %}
[Creating New Tile Providers](/v6/plugins/making-a-plugin/creating-new-tile-providers.md)
{% endcontent-ref %}

{% content-ref url="/pages/PHCyJci0lnfcS8LgyvNw" %}
[Creating New Layers](/v6/plugins/making-a-plugin/creating-new-layers.md)
{% endcontent-ref %}

## Submitting A New Plugin

If you've made your own plugin that you're willing to share, please let us know in the #plugins channel on the flutter\_map Discord server. We can then add it to the [Plugins List](/v6/plugins/list.md). We're always looking forward to see what you've made!

When submitting a plugin, please ensure the plugin:

* *preferably* includes 'flutter\_map\_' in the name, by convention
* is *preferably* available via a standard pub.dev package installation
* includes good documentation (at least to setup basic functionality), and a code example


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.fleaflet.dev/v6/plugins/making-a-plugin.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
